View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.core.buffer;
    21
    22  import java.nio.ByteBuffer;
    23
    24  /**
    25   * Allocates {@link IoBuffer}s and manages them.  Please implement this
    26   * interface if you need more advanced memory management scheme.
    27   *
    28   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    29   */
    30  public interface IoBufferAllocator {
    31      /**
    32       * Returns the buffer which is capable of the specified size.
    33       *
    34       * @param capacity the capacity of the buffer
    35       * @param direct <tt>true</tt> to get a direct buffer,
    36       *               <tt>false</tt> to get a heap buffer.
    37       */
    38      IoBuffer allocate(int capacity, boolean direct);
    39
    40      /**
    41       * Returns the NIO buffer which is capable of the specified size.
    42       *
    43       * @param capacity the capacity of the buffer
    44       * @param direct <tt>true</tt> to get a direct buffer,
    45       *               <tt>false</tt> to get a heap buffer.
    46       */
    47      ByteBuffer allocateNioBuffer(int capacity, boolean direct);
    48
    49      /**
    50       * Wraps the specified NIO {@link ByteBuffer} into MINA buffer.
    51       */
    52      IoBuffer wrap(ByteBuffer nioBuffer);
    53
    54      /**
    55       * Dispose of this allocator.
    56       */
    57      void dispose();
    58  }